<template>
  <div class="mx-auto px-10 py-6">
    <div class="max-w-7xl mx-auto px-4 sm:px-6 md:px-8">
      <h1 class="text-2xl font-semibold text-gray-900">Dashboard</h1>
    </div>
    <div class="max-w-7xl mx-auto py-10 px-4 sm:px-6 md:px-8">
      <h1 class="text-4xl font-semibold text-purple-400">Welcome Back {{ me.name }} !</h1>
    </div>
    <div class="mt-8">
      <div class="max-w-6xl mx-auto px-4 sm:px-6 lg:px-8">
        <h2 class="text-lg leading-6 font-medium text-gray-900">Overview</h2>
        <div class="mt-2 grid grid-cols-1 gap-5 sm:grid-cols-2 lg:grid-cols-3">
          <!-- Card -->
          <div v-if="me && me.roles.includes('ROLE_ADMIN')" class="bg-white overflow-hidden shadow rounded-lg">
            <div class="p-5">
              <div class="flex items-center">
                <div class="flex-shrink-0">
                  <svg class="text-gray-400 group-hover:text-gray-500 mr-3 h-6 w-6" xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                    <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M12 4.354a4 4 0 110 5.292M15 21H3v-1a6 6 0 0112 0v1zm0 0h6v-1a6 6 0 00-9-5.197M13 7a4 4 0 11-8 0 4 4 0 018 0z" />
                  </svg>
                </div>
                <div class="ml-5 w-0 flex-1">
                  <dl>
                    <dt class="text-sm font-medium text-yellow-500 truncate">
                      Users
                    </dt>
                    <dd>
                      <div class="text-lg font-medium text-gray-900">
                        {{ countUser }}
                      </div>
                    </dd>
                  </dl>
                </div>
              </div>
            </div>
            <div class="bg-gray-50 px-5 py-3">
              <div class="text-sm">
                <router-link to="/dashboard/users" class="font-medium text-cyan-700 hover:text-cyan-900">
                  View all
                </router-link>
              </div>
            </div>
          </div>

          <div class="bg-white overflow-hidden shadow rounded-lg">
            <div class="p-5">
              <div class="flex items-center">
                <div class="flex-shrink-0">
                  <svg class="text-gray-400 group-hover:text-gray-500 mr-3 h-6 w-6" xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor" aria-hidden="true">
                    <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M3 7v10a2 2 0 002 2h14a2 2 0 002-2V9a2 2 0 00-2-2h-6l-2-2H5a2 2 0 00-2 2z" />
                  </svg>
                </div>
                <div class="ml-5 w-0 flex-1">
                  <dl>
                    <dt class="text-sm font-medium text-yellow-500 truncate">
                      Projects
                    </dt>
                    <dd>
                      <div class="text-lg font-medium text-gray-900">
                        {{ countProject }}
                      </div>
                    </dd>
                  </dl>
                </div>
              </div>
            </div>
            <div class="bg-gray-50 px-5 py-3">
              <div class="text-sm">
                <router-link to="/projects" class="font-medium text-cyan-700 hover:text-cyan-900">
                  View all
                </router-link>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'

export default {
  name: 'Dashboard',
  computed: {
    ...mapGetters('user', ['me']),
    ...mapGetters('user', ['all']),
    ...mapGetters('project', ['allProjects']),
    countUser () {
      return this.all.length
    },
    countProject () {
      return this.allProjects.length
    }
  },
  methods: {
    ...mapActions('user', {
      fetchAllUsers: 'fetchAll'
    }),
    ...mapActions('project', ['fetchAll'])
  },
  async beforeMount () {
    await this.fetchAllUsers()
    await this.fetchAll()
  }
}
</script>
